#! /bin/bash

TEST_DIR="tests"
SUFFIX="test"
TEST_OUT="/tmp/$$"

numtests=0
passed=0

for t in `ls "$TEST_DIR"`
do
   base=`basename "$t"`
   test=`basename "$t" ".$SUFFIX"`
   if [ "$base" != "$test" ]
   then
      len=`echo "$test" | wc -c`
      numdots=`expr 30 - "$len"`
      dots=""
      while [ "$numdots" -gt 0 ]
      do
         dots="$dots."
         numdots=`expr $numdots - 1`
      done 

      numtests=`expr $numtests + 1`
      echo -n "Testing $test $dots "
      java CourierDelivery "$TEST_DIR/$test.$SUFFIX" | grep -E -v -e '[0-9]+ nodes explored' | grep -v "^potential" > "$TEST_OUT"
      res=`diff "$TEST_DIR/$test.out" "$TEST_OUT" | wc -l`
      if [ "$res" -eq 0 ]
      then
         echo "passed"
         passed=`expr $passed + 1`
      else
         echo "failed"
         echo "Expected | Output"
         diff -y "$TEST_DIR/$test.out" "$TEST_OUT"
      fi
   fi
done

echo "Passed $passed out of $numtests tests"

if [ "$numtests" = "$passed" ]
then
   echo "YOU ARE AWESOME!"
fi

